# Class PVector3F.Builder<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector3F.Builder<T>

Enclosing class:
  `PVector3F<T>`

public static final class PVector3F.Builder<T> extends Object
Builds instances of type `PVector3F`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PVector3F<T>`
  `build()`
  Builds a new `PVector3F`.
  `final PVector3F.Builder<T>`
  `from(PVector3FType<T> instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector3FType` instance.
  `final PVector3F.Builder<T>`
  `from(PVectorReadable3FType<T> instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVectorReadable3FType` instance.
  `final PVector3F.Builder<T>`
  `from(VectorReadable2FType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2FType` instance.
  `final PVector3F.Builder<T>`
  `from(VectorReadable3FType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3FType` instance.
  `final PVector3F.Builder<T>`
  `setX(float x)`
  Initializes the value for the `x` attribute.
  `final PVector3F.Builder<T>`
  `setY(float y)`
  Initializes the value for the `y` attribute.
  `final PVector3F.Builder<T>`
  `setZ(float z)`
  Initializes the value for the `z` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PVector3F.Builder<T> from(VectorReadable2FType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector3F.Builder<T> from(PVector3FType<T> instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector3FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector3F.Builder<T> from(PVectorReadable3FType<T> instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVectorReadable3FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector3F.Builder<T> from(VectorReadable3FType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final PVector3F.Builder<T> setX(float x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final PVector3F.Builder<T> setY(float y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final PVector3F.Builder<T> setZ(float z)
    Initializes the value for the `z` attribute.
    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PVector3F<T> build()
    Builds a new `PVector3F`.
    Returns:
      An immutable instance of PVector3F
    Throws:
      `IllegalStateException` - if any required attributes are missing